import 'package:flutter/material.dart';

class MyCustomTheme {
  static Color primaryColor = const Color.fromARGB(255, 42, 61, 171);
  static Color cardColor = const Color(0xFFECECEC);
  static Color textColor = const Color(0xFF181818);
  static Color bgColor = const Color(0xFFF8FAFC);
  static Color dividerColor = const Color(0xFF4C4C4C);

  static ThemeData theme = ThemeData(
    primaryColor: primaryColor,
    useMaterial3: true,
    cardColor: cardColor,
    scaffoldBackgroundColor: bgColor,
    dividerColor: dividerColor,
    textTheme: TextTheme(
      headlineLarge: TextStyle(
        fontSize: 28,
        fontWeight: FontWeight.bold,
        fontFamily: "Cairo",
        color: textColor,
      ),
      titleLarge: TextStyle(
        fontSize: 22,
        fontWeight: FontWeight.w500,
        fontFamily: "Cairo",
        color: textColor,
      ),
      bodyLarge: TextStyle(
        fontSize: 18,
        fontWeight: FontWeight.normal,
        fontFamily: "Cairo",
        color: textColor,
      ),
      bodyMedium: TextStyle(
        fontSize: 16,
        fontWeight: FontWeight.normal,
        fontFamily: "Cairo",
        color: textColor,
      ),
      bodySmall: TextStyle(
        fontSize: 14,
        fontWeight: FontWeight.normal,
        fontFamily: "Cairo",
        color: textColor,
      ),
    ),
    elevatedButtonTheme: ElevatedButtonThemeData(
        style: ButtonStyle(
      elevation: const WidgetStatePropertyAll(0),
      backgroundColor: WidgetStatePropertyAll(primaryColor),
      shape: WidgetStatePropertyAll(
        RoundedRectangleBorder(
          borderRadius: BorderRadius.circular(10),
        ),
      ),
    )),
    outlinedButtonTheme: OutlinedButtonThemeData(
        style: ButtonStyle(
      elevation: const WidgetStatePropertyAll(0),
      shape: WidgetStatePropertyAll(RoundedRectangleBorder(
        borderRadius: BorderRadius.circular(10),
      )),
    )),
  );
}
