import 'package:baligh/screens/profile_screen.dart';
import 'package:baligh/widgets/baligh_card.dart';
import 'package:flutter/material.dart';
import 'package:font_awesome_flutter/font_awesome_flutter.dart';

class HomeScreen extends StatefulWidget {
  const HomeScreen({super.key});

  @override
  State<HomeScreen> createState() => _HomeScreenState();
}

class _HomeScreenState extends State<HomeScreen> {
  @override
  Widget build(BuildContext context) {
    return Directionality(
      textDirection: TextDirection.rtl,
      child: Scaffold(
        appBar: AppBar(
          centerTitle: true,
          title: Text(
            "البلاغات",
            style: Theme.of(context).textTheme.headlineLarge,
          ),
          backgroundColor: Colors.transparent,
          actions: [
            Padding(
              padding: const EdgeInsets.only(left: 6),
              child: IconButton(
                onPressed: () {
                  Navigator.push(context, (MaterialPageRoute(builder: (context) {
                    return const ProfileScreen();
                  })));
                },
                icon: const Icon(FontAwesomeIcons.user),
              ),
            ),
          ],
        ),
        body: SafeArea(
          child: GridView(
            padding: const EdgeInsets.all(15),
            gridDelegate: const SliverGridDelegateWithFixedCrossAxisCount(
              crossAxisCount: 2,
              mainAxisSpacing: 10,
              crossAxisSpacing: 10,
              childAspectRatio: 1,
            ),
            children: [
              BlighCard(
                icon: FontAwesomeIcons.unlock,
                label: "الابتزاز",
                iconColor: Colors.grey[700] ?? Colors.grey,
              ),
              const BlighCard(
                icon: FontAwesomeIcons.pills,
                label: "المخدرات",
                iconColor: Colors.pink,
              ),
              const BlighCard(
                icon: FontAwesomeIcons.person,
                label: "التحرش",
                iconColor: Colors.purple,
              ),
              BlighCard(
                icon: FontAwesomeIcons.moneyBill,
                label: "الرشوة",
                iconColor: Colors.green[700] ?? Colors.green,
              ),
              BlighCard(
                icon: FontAwesomeIcons.handFist,
                label: "التعنيف",
                iconColor: Colors.yellow[700] ?? Colors.yellow,
              ),
            ],
          ),
        ),
      ),
    );
  }
}
