import 'package:baligh/screens/home_screen.dart';
import 'package:flutter/material.dart';

class SuccessScreen extends StatelessWidget {
  const SuccessScreen({super.key});

  @override
  Widget build(BuildContext context) {
    return Directionality(
      textDirection: TextDirection.rtl, 
      child: Scaffold(
        body: SafeArea(
          child: ListView(
            padding: const EdgeInsets.all(15),
            children: [
              const SizedBox(height: 100,),
              Icon(Icons.done_outline_rounded, size: 85, color: Colors.blue[600],),
              const SizedBox(height: 50,),
              Text(
                "تم ارسال البلاغ",
                style: Theme.of(context).textTheme.titleLarge,
              ),
              const SizedBox(height: 20,),
              Text(
                "تم ارسال بلاغك بنجاح و ستتم مراجعته من قبل الجهات المعنية باقرب وقت",
                style: Theme.of(context).textTheme.bodyMedium,
              ),
              const SizedBox(height: 40,),
              ElevatedButton(
                  onPressed: () {
                    Navigator.pushAndRemoveUntil(context, MaterialPageRoute(builder: (context) => const HomeScreen()), (x) => false);
                  },
                  child: Text(
                    "العودة الى صفحة البلاغات",
                    style: Theme.of(context)
                        .textTheme
                        .bodyLarge
                        ?.copyWith(color: Colors.white),
                  )),
            ],
          ),
        ),
      )
    );
  }
}
